// Automatically generated by FFC, the FEniCS Form Compiler, version 0.2.0.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __ELASTICITYUPDATEDSIGMA_H
#define __ELASTICITYUPDATEDSIGMA_H

#include <dolfin/Mesh.h>
#include <dolfin/Cell.h>
#include <dolfin/Point.h>
#include <dolfin/Vector.h>
#include <dolfin/AffineMap.h>
#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace ElasticityUpdatedSigma {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class LinearForm : public dolfin::LinearForm
{
public:
    
  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 9;
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 9;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.id();
      int offset = mesh.noCells();
      dofs[1] = offset + cell.id();
      offset = offset + mesh.noCells();
      dofs[2] = offset + cell.id();
      offset = offset + mesh.noCells();
      dofs[3] = offset + cell.id();
      offset = offset + mesh.noCells();
      dofs[4] = offset + cell.id();
      offset = offset + mesh.noCells();
      dofs[5] = offset + cell.id();
      offset = offset + mesh.noCells();
      dofs[6] = offset + cell.id();
      offset = offset + mesh.noCells();
      dofs[7] = offset + cell.id();
      offset = offset + mesh.noCells();
      dofs[8] = offset + cell.id();
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[1] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[2] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[3] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[4] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[5] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[6] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[7] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[8] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      components[0] = 0;
      components[1] = 1;
      components[2] = 2;
      components[3] = 3;
      components[4] = 4;
      components[5] = 5;
      components[6] = 6;
      components[7] = 7;
      components[8] = 8;
    }

    void vertexeval(real values[], unsigned int vertex, const Vector& x, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x(vertex);
      int offset = mesh.noCells();
      values[1] = x(offset + vertex);
      offset = offset + mesh.noCells();
      values[2] = x(offset + vertex);
      offset = offset + mesh.noCells();
      values[3] = x(offset + vertex);
      offset = offset + mesh.noCells();
      values[4] = x(offset + vertex);
      offset = offset + mesh.noCells();
      values[5] = x(offset + vertex);
      offset = offset + mesh.noCells();
      values[6] = x(offset + vertex);
      offset = offset + mesh.noCells();
      values[7] = x(offset + vertex);
      offset = offset + mesh.noCells();
      values[8] = x(offset + vertex);
    }

  private:

    unsigned int* tensordims;

  };
    
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.nodeID(0);
      dofs[1] = cell.nodeID(1);
      dofs[2] = cell.nodeID(2);
      dofs[3] = cell.nodeID(3);
      int offset = mesh.noNodes();
      dofs[4] = offset + cell.nodeID(0);
      dofs[5] = offset + cell.nodeID(1);
      dofs[6] = offset + cell.nodeID(2);
      dofs[7] = offset + cell.nodeID(3);
      offset = offset + mesh.noNodes();
      dofs[8] = offset + cell.nodeID(0);
      dofs[9] = offset + cell.nodeID(1);
      dofs[10] = offset + cell.nodeID(2);
      dofs[11] = offset + cell.nodeID(3);
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[3] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[4] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[5] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[6] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[7] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      points[8] = map(0.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[9] = map(1.000000000000000e+00, 0.000000000000000e+00, 0.000000000000000e+00);
      points[10] = map(0.000000000000000e+00, 1.000000000000000e+00, 0.000000000000000e+00);
      points[11] = map(0.000000000000000e+00, 0.000000000000000e+00, 1.000000000000000e+00);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 1;
      components[5] = 1;
      components[6] = 1;
      components[7] = 1;
      components[8] = 2;
      components[9] = 2;
      components[10] = 2;
      components[11] = 2;
    }

    void vertexeval(real values[], unsigned int vertex, const Vector& x, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x(vertex);
      int offset = mesh.noNodes();
      values[1] = x(offset + vertex);
      offset = offset + mesh.noNodes();
      values[2] = x(offset + vertex);
    }

  private:

    unsigned int* tensordims;

  };
    
  class FunctionElement_1 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_1() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 9;
    }

    ~FunctionElement_1()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 9;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.id();
      int offset = mesh.noCells();
      dofs[1] = offset + cell.id();
      offset = offset + mesh.noCells();
      dofs[2] = offset + cell.id();
      offset = offset + mesh.noCells();
      dofs[3] = offset + cell.id();
      offset = offset + mesh.noCells();
      dofs[4] = offset + cell.id();
      offset = offset + mesh.noCells();
      dofs[5] = offset + cell.id();
      offset = offset + mesh.noCells();
      dofs[6] = offset + cell.id();
      offset = offset + mesh.noCells();
      dofs[7] = offset + cell.id();
      offset = offset + mesh.noCells();
      dofs[8] = offset + cell.id();
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[1] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[2] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[3] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[4] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[5] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[6] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[7] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      points[8] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      components[0] = 0;
      components[1] = 1;
      components[2] = 2;
      components[3] = 3;
      components[4] = 4;
      components[5] = 5;
      components[6] = 6;
      components[7] = 7;
      components[8] = 8;
    }

    void vertexeval(real values[], unsigned int vertex, const Vector& x, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x(vertex);
      int offset = mesh.noCells();
      values[1] = x(offset + vertex);
      offset = offset + mesh.noCells();
      values[2] = x(offset + vertex);
      offset = offset + mesh.noCells();
      values[3] = x(offset + vertex);
      offset = offset + mesh.noCells();
      values[4] = x(offset + vertex);
      offset = offset + mesh.noCells();
      values[5] = x(offset + vertex);
      offset = offset + mesh.noCells();
      values[6] = x(offset + vertex);
      offset = offset + mesh.noCells();
      values[7] = x(offset + vertex);
      offset = offset + mesh.noCells();
      values[8] = x(offset + vertex);
    }

  private:

    unsigned int* tensordims;

  };
    
  class FunctionElement_2 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_2() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 1;
    }

    ~FunctionElement_2()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 1;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    void dofmap(int dofs[], const Cell& cell, const Mesh& mesh) const
    {
      dofs[0] = cell.id();
    }

    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(2.500000000000000e-01, 2.500000000000000e-01, 2.500000000000000e-01);
      components[0] = 0;
    }

    void vertexeval(real values[], unsigned int vertex, const Vector& x, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      values[0] = x(vertex);
    }

  private:

    unsigned int* tensordims;

  };

  LinearForm(Function& w0, Function& w1, Function& w2, const real& c0, const real& c1, const real& c2) : dolfin::LinearForm(3), c0(c0), c1(c1), c2(c2)
  {
    // Create finite element for test space
    _test = new TestElement();
        
    // Add functions
    add(w0, new FunctionElement_0());
    add(w1, new FunctionElement_1());
    add(w2, new FunctionElement_2());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    real G0_0_0 = map.det*c1*c[0][0]*map.g00 + map.det*c1*c[0][0]*map.g00;
    real G0_0_1 = map.det*c1*c[0][0]*map.g10 + map.det*c1*c[0][0]*map.g10;
    real G0_0_2 = map.det*c1*c[0][0]*map.g20 + map.det*c1*c[0][0]*map.g20;
    real G0_1_0 = map.det*c1*c[0][1]*map.g00 + map.det*c1*c[0][1]*map.g00;
    real G0_2_1 = map.det*c1*c[0][2]*map.g10 + map.det*c1*c[0][2]*map.g10;
    real G0_3_2 = map.det*c1*c[0][3]*map.g20 + map.det*c1*c[0][3]*map.g20;
    real G1_0_0 = map.det*c0*c[0][0]*map.g00 + map.det*c0*c[0][0]*map.g00;
    real G1_0_1 = map.det*c0*c[0][0]*map.g10 + map.det*c0*c[0][0]*map.g10;
    real G1_0_2 = map.det*c0*c[0][0]*map.g20 + map.det*c0*c[0][0]*map.g20;
    real G1_1_0 = map.det*c0*c[0][1]*map.g00 + map.det*c0*c[0][1]*map.g00;
    real G1_2_1 = map.det*c0*c[0][2]*map.g10 + map.det*c0*c[0][2]*map.g10;
    real G1_3_2 = map.det*c0*c[0][3]*map.g20 + map.det*c0*c[0][3]*map.g20;
    real G2_4_0 = map.det*c0*c[0][4]*map.g01 + map.det*c0*c[0][4]*map.g01;
    real G2_4_1 = map.det*c0*c[0][4]*map.g11 + map.det*c0*c[0][4]*map.g11;
    real G2_4_2 = map.det*c0*c[0][4]*map.g21 + map.det*c0*c[0][4]*map.g21;
    real G2_5_0 = map.det*c0*c[0][5]*map.g01 + map.det*c0*c[0][5]*map.g01;
    real G2_6_1 = map.det*c0*c[0][6]*map.g11 + map.det*c0*c[0][6]*map.g11;
    real G2_7_2 = map.det*c0*c[0][7]*map.g21 + map.det*c0*c[0][7]*map.g21;
    real G3_8_0 = map.det*c0*c[0][8]*map.g02 + map.det*c0*c[0][8]*map.g02;
    real G3_8_1 = map.det*c0*c[0][8]*map.g12 + map.det*c0*c[0][8]*map.g12;
    real G3_8_2 = map.det*c0*c[0][8]*map.g22 + map.det*c0*c[0][8]*map.g22;
    real G3_9_0 = map.det*c0*c[0][9]*map.g02 + map.det*c0*c[0][9]*map.g02;
    real G3_10_1 = map.det*c0*c[0][10]*map.g12 + map.det*c0*c[0][10]*map.g12;
    real G3_11_2 = map.det*c0*c[0][11]*map.g22 + map.det*c0*c[0][11]*map.g22;
    real G4_0_0 = map.det*c1*c[0][0]*map.g01;
    real G4_0_1 = map.det*c1*c[0][0]*map.g11;
    real G4_0_2 = map.det*c1*c[0][0]*map.g21;
    real G4_1_0 = map.det*c1*c[0][1]*map.g01;
    real G4_2_1 = map.det*c1*c[0][2]*map.g11;
    real G4_3_2 = map.det*c1*c[0][3]*map.g21;
    real G5_4_0 = map.det*c1*c[0][4]*map.g00;
    real G5_4_1 = map.det*c1*c[0][4]*map.g10;
    real G5_4_2 = map.det*c1*c[0][4]*map.g20;
    real G5_5_0 = map.det*c1*c[0][5]*map.g00;
    real G5_6_1 = map.det*c1*c[0][6]*map.g10;
    real G5_7_2 = map.det*c1*c[0][7]*map.g20;
    real G9_0_0 = map.det*c1*c[0][0]*map.g02;
    real G9_0_1 = map.det*c1*c[0][0]*map.g12;
    real G9_0_2 = map.det*c1*c[0][0]*map.g22;
    real G9_1_0 = map.det*c1*c[0][1]*map.g02;
    real G9_2_1 = map.det*c1*c[0][2]*map.g12;
    real G9_3_2 = map.det*c1*c[0][3]*map.g22;
    real G10_8_0 = map.det*c1*c[0][8]*map.g00;
    real G10_8_1 = map.det*c1*c[0][8]*map.g10;
    real G10_8_2 = map.det*c1*c[0][8]*map.g20;
    real G10_9_0 = map.det*c1*c[0][9]*map.g00;
    real G10_10_1 = map.det*c1*c[0][10]*map.g10;
    real G10_11_2 = map.det*c1*c[0][11]*map.g20;
    real G14_4_0 = map.det*c1*c[0][4]*map.g00;
    real G14_4_1 = map.det*c1*c[0][4]*map.g10;
    real G14_4_2 = map.det*c1*c[0][4]*map.g20;
    real G14_5_0 = map.det*c1*c[0][5]*map.g00;
    real G14_6_1 = map.det*c1*c[0][6]*map.g10;
    real G14_7_2 = map.det*c1*c[0][7]*map.g20;
    real G15_0_0 = map.det*c1*c[0][0]*map.g01;
    real G15_0_1 = map.det*c1*c[0][0]*map.g11;
    real G15_0_2 = map.det*c1*c[0][0]*map.g21;
    real G15_1_0 = map.det*c1*c[0][1]*map.g01;
    real G15_2_1 = map.det*c1*c[0][2]*map.g11;
    real G15_3_2 = map.det*c1*c[0][3]*map.g21;
    real G19_4_0 = map.det*c1*c[0][4]*map.g01 + map.det*c1*c[0][4]*map.g01;
    real G19_4_1 = map.det*c1*c[0][4]*map.g11 + map.det*c1*c[0][4]*map.g11;
    real G19_4_2 = map.det*c1*c[0][4]*map.g21 + map.det*c1*c[0][4]*map.g21;
    real G19_5_0 = map.det*c1*c[0][5]*map.g01 + map.det*c1*c[0][5]*map.g01;
    real G19_6_1 = map.det*c1*c[0][6]*map.g11 + map.det*c1*c[0][6]*map.g11;
    real G19_7_2 = map.det*c1*c[0][7]*map.g21 + map.det*c1*c[0][7]*map.g21;
    real G20_0_0 = map.det*c0*c[0][0]*map.g00 + map.det*c0*c[0][0]*map.g00;
    real G20_0_1 = map.det*c0*c[0][0]*map.g10 + map.det*c0*c[0][0]*map.g10;
    real G20_0_2 = map.det*c0*c[0][0]*map.g20 + map.det*c0*c[0][0]*map.g20;
    real G20_1_0 = map.det*c0*c[0][1]*map.g00 + map.det*c0*c[0][1]*map.g00;
    real G20_2_1 = map.det*c0*c[0][2]*map.g10 + map.det*c0*c[0][2]*map.g10;
    real G20_3_2 = map.det*c0*c[0][3]*map.g20 + map.det*c0*c[0][3]*map.g20;
    real G21_4_0 = map.det*c0*c[0][4]*map.g01 + map.det*c0*c[0][4]*map.g01;
    real G21_4_1 = map.det*c0*c[0][4]*map.g11 + map.det*c0*c[0][4]*map.g11;
    real G21_4_2 = map.det*c0*c[0][4]*map.g21 + map.det*c0*c[0][4]*map.g21;
    real G21_5_0 = map.det*c0*c[0][5]*map.g01 + map.det*c0*c[0][5]*map.g01;
    real G21_6_1 = map.det*c0*c[0][6]*map.g11 + map.det*c0*c[0][6]*map.g11;
    real G21_7_2 = map.det*c0*c[0][7]*map.g21 + map.det*c0*c[0][7]*map.g21;
    real G22_8_0 = map.det*c0*c[0][8]*map.g02 + map.det*c0*c[0][8]*map.g02;
    real G22_8_1 = map.det*c0*c[0][8]*map.g12 + map.det*c0*c[0][8]*map.g12;
    real G22_8_2 = map.det*c0*c[0][8]*map.g22 + map.det*c0*c[0][8]*map.g22;
    real G22_9_0 = map.det*c0*c[0][9]*map.g02 + map.det*c0*c[0][9]*map.g02;
    real G22_10_1 = map.det*c0*c[0][10]*map.g12 + map.det*c0*c[0][10]*map.g12;
    real G22_11_2 = map.det*c0*c[0][11]*map.g22 + map.det*c0*c[0][11]*map.g22;
    real G23_4_0 = map.det*c1*c[0][4]*map.g02;
    real G23_4_1 = map.det*c1*c[0][4]*map.g12;
    real G23_4_2 = map.det*c1*c[0][4]*map.g22;
    real G23_5_0 = map.det*c1*c[0][5]*map.g02;
    real G23_6_1 = map.det*c1*c[0][6]*map.g12;
    real G23_7_2 = map.det*c1*c[0][7]*map.g22;
    real G24_8_0 = map.det*c1*c[0][8]*map.g01;
    real G24_8_1 = map.det*c1*c[0][8]*map.g11;
    real G24_8_2 = map.det*c1*c[0][8]*map.g21;
    real G24_9_0 = map.det*c1*c[0][9]*map.g01;
    real G24_10_1 = map.det*c1*c[0][10]*map.g11;
    real G24_11_2 = map.det*c1*c[0][11]*map.g21;
    real G28_8_0 = map.det*c1*c[0][8]*map.g00;
    real G28_8_1 = map.det*c1*c[0][8]*map.g10;
    real G28_8_2 = map.det*c1*c[0][8]*map.g20;
    real G28_9_0 = map.det*c1*c[0][9]*map.g00;
    real G28_10_1 = map.det*c1*c[0][10]*map.g10;
    real G28_11_2 = map.det*c1*c[0][11]*map.g20;
    real G29_0_0 = map.det*c1*c[0][0]*map.g02;
    real G29_0_1 = map.det*c1*c[0][0]*map.g12;
    real G29_0_2 = map.det*c1*c[0][0]*map.g22;
    real G29_1_0 = map.det*c1*c[0][1]*map.g02;
    real G29_2_1 = map.det*c1*c[0][2]*map.g12;
    real G29_3_2 = map.det*c1*c[0][3]*map.g22;
    real G33_8_0 = map.det*c1*c[0][8]*map.g01;
    real G33_8_1 = map.det*c1*c[0][8]*map.g11;
    real G33_8_2 = map.det*c1*c[0][8]*map.g21;
    real G33_9_0 = map.det*c1*c[0][9]*map.g01;
    real G33_10_1 = map.det*c1*c[0][10]*map.g11;
    real G33_11_2 = map.det*c1*c[0][11]*map.g21;
    real G34_4_0 = map.det*c1*c[0][4]*map.g02;
    real G34_4_1 = map.det*c1*c[0][4]*map.g12;
    real G34_4_2 = map.det*c1*c[0][4]*map.g22;
    real G34_5_0 = map.det*c1*c[0][5]*map.g02;
    real G34_6_1 = map.det*c1*c[0][6]*map.g12;
    real G34_7_2 = map.det*c1*c[0][7]*map.g22;
    real G38_8_0 = map.det*c1*c[0][8]*map.g02 + map.det*c1*c[0][8]*map.g02;
    real G38_8_1 = map.det*c1*c[0][8]*map.g12 + map.det*c1*c[0][8]*map.g12;
    real G38_8_2 = map.det*c1*c[0][8]*map.g22 + map.det*c1*c[0][8]*map.g22;
    real G38_9_0 = map.det*c1*c[0][9]*map.g02 + map.det*c1*c[0][9]*map.g02;
    real G38_10_1 = map.det*c1*c[0][10]*map.g12 + map.det*c1*c[0][10]*map.g12;
    real G38_11_2 = map.det*c1*c[0][11]*map.g22 + map.det*c1*c[0][11]*map.g22;
    real G39_0_0 = map.det*c0*c[0][0]*map.g00 + map.det*c0*c[0][0]*map.g00;
    real G39_0_1 = map.det*c0*c[0][0]*map.g10 + map.det*c0*c[0][0]*map.g10;
    real G39_0_2 = map.det*c0*c[0][0]*map.g20 + map.det*c0*c[0][0]*map.g20;
    real G39_1_0 = map.det*c0*c[0][1]*map.g00 + map.det*c0*c[0][1]*map.g00;
    real G39_2_1 = map.det*c0*c[0][2]*map.g10 + map.det*c0*c[0][2]*map.g10;
    real G39_3_2 = map.det*c0*c[0][3]*map.g20 + map.det*c0*c[0][3]*map.g20;
    real G40_4_0 = map.det*c0*c[0][4]*map.g01 + map.det*c0*c[0][4]*map.g01;
    real G40_4_1 = map.det*c0*c[0][4]*map.g11 + map.det*c0*c[0][4]*map.g11;
    real G40_4_2 = map.det*c0*c[0][4]*map.g21 + map.det*c0*c[0][4]*map.g21;
    real G40_5_0 = map.det*c0*c[0][5]*map.g01 + map.det*c0*c[0][5]*map.g01;
    real G40_6_1 = map.det*c0*c[0][6]*map.g11 + map.det*c0*c[0][6]*map.g11;
    real G40_7_2 = map.det*c0*c[0][7]*map.g21 + map.det*c0*c[0][7]*map.g21;
    real G41_8_0 = map.det*c0*c[0][8]*map.g02 + map.det*c0*c[0][8]*map.g02;
    real G41_8_1 = map.det*c0*c[0][8]*map.g12 + map.det*c0*c[0][8]*map.g12;
    real G41_8_2 = map.det*c0*c[0][8]*map.g22 + map.det*c0*c[0][8]*map.g22;
    real G41_9_0 = map.det*c0*c[0][9]*map.g02 + map.det*c0*c[0][9]*map.g02;
    real G41_10_1 = map.det*c0*c[0][10]*map.g12 + map.det*c0*c[0][10]*map.g12;
    real G41_11_2 = map.det*c0*c[0][11]*map.g22 + map.det*c0*c[0][11]*map.g22;
    real G42_0_0_0 = map.det*c[0][0]*c[1][0]*map.g00;
    real G42_0_0_1 = map.det*c[0][0]*c[1][0]*map.g10;
    real G42_0_0_2 = map.det*c[0][0]*c[1][0]*map.g20;
    real G42_0_1_0 = map.det*c[0][1]*c[1][0]*map.g00;
    real G42_0_2_1 = map.det*c[0][2]*c[1][0]*map.g10;
    real G42_0_3_2 = map.det*c[0][3]*c[1][0]*map.g20;
    real G43_1_0_0 = map.det*c[0][0]*c[1][1]*map.g01;
    real G43_1_0_1 = map.det*c[0][0]*c[1][1]*map.g11;
    real G43_1_0_2 = map.det*c[0][0]*c[1][1]*map.g21;
    real G43_1_1_0 = map.det*c[0][1]*c[1][1]*map.g01;
    real G43_1_2_1 = map.det*c[0][2]*c[1][1]*map.g11;
    real G43_1_3_2 = map.det*c[0][3]*c[1][1]*map.g21;
    real G44_2_0_0 = map.det*c[0][0]*c[1][2]*map.g02;
    real G44_2_0_1 = map.det*c[0][0]*c[1][2]*map.g12;
    real G44_2_0_2 = map.det*c[0][0]*c[1][2]*map.g22;
    real G44_2_1_0 = map.det*c[0][1]*c[1][2]*map.g02;
    real G44_2_2_1 = map.det*c[0][2]*c[1][2]*map.g12;
    real G44_2_3_2 = map.det*c[0][3]*c[1][2]*map.g22;
    real G45_0_0_0 = map.det*c[1][0]*c[0][0]*map.g00;
    real G45_0_0_1 = map.det*c[1][0]*c[0][0]*map.g10;
    real G45_0_0_2 = map.det*c[1][0]*c[0][0]*map.g20;
    real G45_0_1_0 = map.det*c[1][0]*c[0][1]*map.g00;
    real G45_0_2_1 = map.det*c[1][0]*c[0][2]*map.g10;
    real G45_0_3_2 = map.det*c[1][0]*c[0][3]*map.g20;
    real G46_3_4_0 = map.det*c[1][3]*c[0][4]*map.g00;
    real G46_3_4_1 = map.det*c[1][3]*c[0][4]*map.g10;
    real G46_3_4_2 = map.det*c[1][3]*c[0][4]*map.g20;
    real G46_3_5_0 = map.det*c[1][3]*c[0][5]*map.g00;
    real G46_3_6_1 = map.det*c[1][3]*c[0][6]*map.g10;
    real G46_3_7_2 = map.det*c[1][3]*c[0][7]*map.g20;
    real G47_6_8_0 = map.det*c[1][6]*c[0][8]*map.g00;
    real G47_6_8_1 = map.det*c[1][6]*c[0][8]*map.g10;
    real G47_6_8_2 = map.det*c[1][6]*c[0][8]*map.g20;
    real G47_6_9_0 = map.det*c[1][6]*c[0][9]*map.g00;
    real G47_6_10_1 = map.det*c[1][6]*c[0][10]*map.g10;
    real G47_6_11_2 = map.det*c[1][6]*c[0][11]*map.g20;
    real G48_3_0_0 = map.det*c[0][0]*c[1][3]*map.g00;
    real G48_3_0_1 = map.det*c[0][0]*c[1][3]*map.g10;
    real G48_3_0_2 = map.det*c[0][0]*c[1][3]*map.g20;
    real G48_3_1_0 = map.det*c[0][1]*c[1][3]*map.g00;
    real G48_3_2_1 = map.det*c[0][2]*c[1][3]*map.g10;
    real G48_3_3_2 = map.det*c[0][3]*c[1][3]*map.g20;
    real G49_4_0_0 = map.det*c[0][0]*c[1][4]*map.g01;
    real G49_4_0_1 = map.det*c[0][0]*c[1][4]*map.g11;
    real G49_4_0_2 = map.det*c[0][0]*c[1][4]*map.g21;
    real G49_4_1_0 = map.det*c[0][1]*c[1][4]*map.g01;
    real G49_4_2_1 = map.det*c[0][2]*c[1][4]*map.g11;
    real G49_4_3_2 = map.det*c[0][3]*c[1][4]*map.g21;
    real G50_5_0_0 = map.det*c[0][0]*c[1][5]*map.g02;
    real G50_5_0_1 = map.det*c[0][0]*c[1][5]*map.g12;
    real G50_5_0_2 = map.det*c[0][0]*c[1][5]*map.g22;
    real G50_5_1_0 = map.det*c[0][1]*c[1][5]*map.g02;
    real G50_5_2_1 = map.det*c[0][2]*c[1][5]*map.g12;
    real G50_5_3_2 = map.det*c[0][3]*c[1][5]*map.g22;
    real G51_0_0_0 = map.det*c[1][0]*c[0][0]*map.g01;
    real G51_0_0_1 = map.det*c[1][0]*c[0][0]*map.g11;
    real G51_0_0_2 = map.det*c[1][0]*c[0][0]*map.g21;
    real G51_0_1_0 = map.det*c[1][0]*c[0][1]*map.g01;
    real G51_0_2_1 = map.det*c[1][0]*c[0][2]*map.g11;
    real G51_0_3_2 = map.det*c[1][0]*c[0][3]*map.g21;
    real G52_3_4_0 = map.det*c[1][3]*c[0][4]*map.g01;
    real G52_3_4_1 = map.det*c[1][3]*c[0][4]*map.g11;
    real G52_3_4_2 = map.det*c[1][3]*c[0][4]*map.g21;
    real G52_3_5_0 = map.det*c[1][3]*c[0][5]*map.g01;
    real G52_3_6_1 = map.det*c[1][3]*c[0][6]*map.g11;
    real G52_3_7_2 = map.det*c[1][3]*c[0][7]*map.g21;
    real G53_6_8_0 = map.det*c[1][6]*c[0][8]*map.g01;
    real G53_6_8_1 = map.det*c[1][6]*c[0][8]*map.g11;
    real G53_6_8_2 = map.det*c[1][6]*c[0][8]*map.g21;
    real G53_6_9_0 = map.det*c[1][6]*c[0][9]*map.g01;
    real G53_6_10_1 = map.det*c[1][6]*c[0][10]*map.g11;
    real G53_6_11_2 = map.det*c[1][6]*c[0][11]*map.g21;
    real G54_6_0_0 = map.det*c[0][0]*c[1][6]*map.g00;
    real G54_6_0_1 = map.det*c[0][0]*c[1][6]*map.g10;
    real G54_6_0_2 = map.det*c[0][0]*c[1][6]*map.g20;
    real G54_6_1_0 = map.det*c[0][1]*c[1][6]*map.g00;
    real G54_6_2_1 = map.det*c[0][2]*c[1][6]*map.g10;
    real G54_6_3_2 = map.det*c[0][3]*c[1][6]*map.g20;
    real G55_7_0_0 = map.det*c[0][0]*c[1][7]*map.g01;
    real G55_7_0_1 = map.det*c[0][0]*c[1][7]*map.g11;
    real G55_7_0_2 = map.det*c[0][0]*c[1][7]*map.g21;
    real G55_7_1_0 = map.det*c[0][1]*c[1][7]*map.g01;
    real G55_7_2_1 = map.det*c[0][2]*c[1][7]*map.g11;
    real G55_7_3_2 = map.det*c[0][3]*c[1][7]*map.g21;
    real G56_8_0_0 = map.det*c[0][0]*c[1][8]*map.g02;
    real G56_8_0_1 = map.det*c[0][0]*c[1][8]*map.g12;
    real G56_8_0_2 = map.det*c[0][0]*c[1][8]*map.g22;
    real G56_8_1_0 = map.det*c[0][1]*c[1][8]*map.g02;
    real G56_8_2_1 = map.det*c[0][2]*c[1][8]*map.g12;
    real G56_8_3_2 = map.det*c[0][3]*c[1][8]*map.g22;
    real G57_0_0_0 = map.det*c[1][0]*c[0][0]*map.g02;
    real G57_0_0_1 = map.det*c[1][0]*c[0][0]*map.g12;
    real G57_0_0_2 = map.det*c[1][0]*c[0][0]*map.g22;
    real G57_0_1_0 = map.det*c[1][0]*c[0][1]*map.g02;
    real G57_0_2_1 = map.det*c[1][0]*c[0][2]*map.g12;
    real G57_0_3_2 = map.det*c[1][0]*c[0][3]*map.g22;
    real G58_3_4_0 = map.det*c[1][3]*c[0][4]*map.g02;
    real G58_3_4_1 = map.det*c[1][3]*c[0][4]*map.g12;
    real G58_3_4_2 = map.det*c[1][3]*c[0][4]*map.g22;
    real G58_3_5_0 = map.det*c[1][3]*c[0][5]*map.g02;
    real G58_3_6_1 = map.det*c[1][3]*c[0][6]*map.g12;
    real G58_3_7_2 = map.det*c[1][3]*c[0][7]*map.g22;
    real G59_6_8_0 = map.det*c[1][6]*c[0][8]*map.g02;
    real G59_6_8_1 = map.det*c[1][6]*c[0][8]*map.g12;
    real G59_6_8_2 = map.det*c[1][6]*c[0][8]*map.g22;
    real G59_6_9_0 = map.det*c[1][6]*c[0][9]*map.g02;
    real G59_6_10_1 = map.det*c[1][6]*c[0][10]*map.g12;
    real G59_6_11_2 = map.det*c[1][6]*c[0][11]*map.g22;
    real G60_0_4_0 = map.det*c[0][4]*c[1][0]*map.g00;
    real G60_0_4_1 = map.det*c[0][4]*c[1][0]*map.g10;
    real G60_0_4_2 = map.det*c[0][4]*c[1][0]*map.g20;
    real G60_0_5_0 = map.det*c[0][5]*c[1][0]*map.g00;
    real G60_0_6_1 = map.det*c[0][6]*c[1][0]*map.g10;
    real G60_0_7_2 = map.det*c[0][7]*c[1][0]*map.g20;
    real G61_1_4_0 = map.det*c[0][4]*c[1][1]*map.g01;
    real G61_1_4_1 = map.det*c[0][4]*c[1][1]*map.g11;
    real G61_1_4_2 = map.det*c[0][4]*c[1][1]*map.g21;
    real G61_1_5_0 = map.det*c[0][5]*c[1][1]*map.g01;
    real G61_1_6_1 = map.det*c[0][6]*c[1][1]*map.g11;
    real G61_1_7_2 = map.det*c[0][7]*c[1][1]*map.g21;
    real G62_2_4_0 = map.det*c[0][4]*c[1][2]*map.g02;
    real G62_2_4_1 = map.det*c[0][4]*c[1][2]*map.g12;
    real G62_2_4_2 = map.det*c[0][4]*c[1][2]*map.g22;
    real G62_2_5_0 = map.det*c[0][5]*c[1][2]*map.g02;
    real G62_2_6_1 = map.det*c[0][6]*c[1][2]*map.g12;
    real G62_2_7_2 = map.det*c[0][7]*c[1][2]*map.g22;
    real G63_1_0_0 = map.det*c[1][1]*c[0][0]*map.g00;
    real G63_1_0_1 = map.det*c[1][1]*c[0][0]*map.g10;
    real G63_1_0_2 = map.det*c[1][1]*c[0][0]*map.g20;
    real G63_1_1_0 = map.det*c[1][1]*c[0][1]*map.g00;
    real G63_1_2_1 = map.det*c[1][1]*c[0][2]*map.g10;
    real G63_1_3_2 = map.det*c[1][1]*c[0][3]*map.g20;
    real G64_4_4_0 = map.det*c[1][4]*c[0][4]*map.g00;
    real G64_4_4_1 = map.det*c[1][4]*c[0][4]*map.g10;
    real G64_4_4_2 = map.det*c[1][4]*c[0][4]*map.g20;
    real G64_4_5_0 = map.det*c[1][4]*c[0][5]*map.g00;
    real G64_4_6_1 = map.det*c[1][4]*c[0][6]*map.g10;
    real G64_4_7_2 = map.det*c[1][4]*c[0][7]*map.g20;
    real G65_7_8_0 = map.det*c[1][7]*c[0][8]*map.g00;
    real G65_7_8_1 = map.det*c[1][7]*c[0][8]*map.g10;
    real G65_7_8_2 = map.det*c[1][7]*c[0][8]*map.g20;
    real G65_7_9_0 = map.det*c[1][7]*c[0][9]*map.g00;
    real G65_7_10_1 = map.det*c[1][7]*c[0][10]*map.g10;
    real G65_7_11_2 = map.det*c[1][7]*c[0][11]*map.g20;
    real G66_3_4_0 = map.det*c[0][4]*c[1][3]*map.g00;
    real G66_3_4_1 = map.det*c[0][4]*c[1][3]*map.g10;
    real G66_3_4_2 = map.det*c[0][4]*c[1][3]*map.g20;
    real G66_3_5_0 = map.det*c[0][5]*c[1][3]*map.g00;
    real G66_3_6_1 = map.det*c[0][6]*c[1][3]*map.g10;
    real G66_3_7_2 = map.det*c[0][7]*c[1][3]*map.g20;
    real G67_4_4_0 = map.det*c[0][4]*c[1][4]*map.g01;
    real G67_4_4_1 = map.det*c[0][4]*c[1][4]*map.g11;
    real G67_4_4_2 = map.det*c[0][4]*c[1][4]*map.g21;
    real G67_4_5_0 = map.det*c[0][5]*c[1][4]*map.g01;
    real G67_4_6_1 = map.det*c[0][6]*c[1][4]*map.g11;
    real G67_4_7_2 = map.det*c[0][7]*c[1][4]*map.g21;
    real G68_5_4_0 = map.det*c[0][4]*c[1][5]*map.g02;
    real G68_5_4_1 = map.det*c[0][4]*c[1][5]*map.g12;
    real G68_5_4_2 = map.det*c[0][4]*c[1][5]*map.g22;
    real G68_5_5_0 = map.det*c[0][5]*c[1][5]*map.g02;
    real G68_5_6_1 = map.det*c[0][6]*c[1][5]*map.g12;
    real G68_5_7_2 = map.det*c[0][7]*c[1][5]*map.g22;
    real G69_1_0_0 = map.det*c[1][1]*c[0][0]*map.g01;
    real G69_1_0_1 = map.det*c[1][1]*c[0][0]*map.g11;
    real G69_1_0_2 = map.det*c[1][1]*c[0][0]*map.g21;
    real G69_1_1_0 = map.det*c[1][1]*c[0][1]*map.g01;
    real G69_1_2_1 = map.det*c[1][1]*c[0][2]*map.g11;
    real G69_1_3_2 = map.det*c[1][1]*c[0][3]*map.g21;
    real G70_4_4_0 = map.det*c[1][4]*c[0][4]*map.g01;
    real G70_4_4_1 = map.det*c[1][4]*c[0][4]*map.g11;
    real G70_4_4_2 = map.det*c[1][4]*c[0][4]*map.g21;
    real G70_4_5_0 = map.det*c[1][4]*c[0][5]*map.g01;
    real G70_4_6_1 = map.det*c[1][4]*c[0][6]*map.g11;
    real G70_4_7_2 = map.det*c[1][4]*c[0][7]*map.g21;
    real G71_7_8_0 = map.det*c[1][7]*c[0][8]*map.g01;
    real G71_7_8_1 = map.det*c[1][7]*c[0][8]*map.g11;
    real G71_7_8_2 = map.det*c[1][7]*c[0][8]*map.g21;
    real G71_7_9_0 = map.det*c[1][7]*c[0][9]*map.g01;
    real G71_7_10_1 = map.det*c[1][7]*c[0][10]*map.g11;
    real G71_7_11_2 = map.det*c[1][7]*c[0][11]*map.g21;
    real G72_6_4_0 = map.det*c[0][4]*c[1][6]*map.g00;
    real G72_6_4_1 = map.det*c[0][4]*c[1][6]*map.g10;
    real G72_6_4_2 = map.det*c[0][4]*c[1][6]*map.g20;
    real G72_6_5_0 = map.det*c[0][5]*c[1][6]*map.g00;
    real G72_6_6_1 = map.det*c[0][6]*c[1][6]*map.g10;
    real G72_6_7_2 = map.det*c[0][7]*c[1][6]*map.g20;
    real G73_7_4_0 = map.det*c[0][4]*c[1][7]*map.g01;
    real G73_7_4_1 = map.det*c[0][4]*c[1][7]*map.g11;
    real G73_7_4_2 = map.det*c[0][4]*c[1][7]*map.g21;
    real G73_7_5_0 = map.det*c[0][5]*c[1][7]*map.g01;
    real G73_7_6_1 = map.det*c[0][6]*c[1][7]*map.g11;
    real G73_7_7_2 = map.det*c[0][7]*c[1][7]*map.g21;
    real G74_8_4_0 = map.det*c[0][4]*c[1][8]*map.g02;
    real G74_8_4_1 = map.det*c[0][4]*c[1][8]*map.g12;
    real G74_8_4_2 = map.det*c[0][4]*c[1][8]*map.g22;
    real G74_8_5_0 = map.det*c[0][5]*c[1][8]*map.g02;
    real G74_8_6_1 = map.det*c[0][6]*c[1][8]*map.g12;
    real G74_8_7_2 = map.det*c[0][7]*c[1][8]*map.g22;
    real G75_1_0_0 = map.det*c[1][1]*c[0][0]*map.g02;
    real G75_1_0_1 = map.det*c[1][1]*c[0][0]*map.g12;
    real G75_1_0_2 = map.det*c[1][1]*c[0][0]*map.g22;
    real G75_1_1_0 = map.det*c[1][1]*c[0][1]*map.g02;
    real G75_1_2_1 = map.det*c[1][1]*c[0][2]*map.g12;
    real G75_1_3_2 = map.det*c[1][1]*c[0][3]*map.g22;
    real G76_4_4_0 = map.det*c[1][4]*c[0][4]*map.g02;
    real G76_4_4_1 = map.det*c[1][4]*c[0][4]*map.g12;
    real G76_4_4_2 = map.det*c[1][4]*c[0][4]*map.g22;
    real G76_4_5_0 = map.det*c[1][4]*c[0][5]*map.g02;
    real G76_4_6_1 = map.det*c[1][4]*c[0][6]*map.g12;
    real G76_4_7_2 = map.det*c[1][4]*c[0][7]*map.g22;
    real G77_7_8_0 = map.det*c[1][7]*c[0][8]*map.g02;
    real G77_7_8_1 = map.det*c[1][7]*c[0][8]*map.g12;
    real G77_7_8_2 = map.det*c[1][7]*c[0][8]*map.g22;
    real G77_7_9_0 = map.det*c[1][7]*c[0][9]*map.g02;
    real G77_7_10_1 = map.det*c[1][7]*c[0][10]*map.g12;
    real G77_7_11_2 = map.det*c[1][7]*c[0][11]*map.g22;
    real G78_0_8_0 = map.det*c[0][8]*c[1][0]*map.g00;
    real G78_0_8_1 = map.det*c[0][8]*c[1][0]*map.g10;
    real G78_0_8_2 = map.det*c[0][8]*c[1][0]*map.g20;
    real G78_0_9_0 = map.det*c[0][9]*c[1][0]*map.g00;
    real G78_0_10_1 = map.det*c[0][10]*c[1][0]*map.g10;
    real G78_0_11_2 = map.det*c[0][11]*c[1][0]*map.g20;
    real G79_1_8_0 = map.det*c[0][8]*c[1][1]*map.g01;
    real G79_1_8_1 = map.det*c[0][8]*c[1][1]*map.g11;
    real G79_1_8_2 = map.det*c[0][8]*c[1][1]*map.g21;
    real G79_1_9_0 = map.det*c[0][9]*c[1][1]*map.g01;
    real G79_1_10_1 = map.det*c[0][10]*c[1][1]*map.g11;
    real G79_1_11_2 = map.det*c[0][11]*c[1][1]*map.g21;
    real G80_2_8_0 = map.det*c[0][8]*c[1][2]*map.g02;
    real G80_2_8_1 = map.det*c[0][8]*c[1][2]*map.g12;
    real G80_2_8_2 = map.det*c[0][8]*c[1][2]*map.g22;
    real G80_2_9_0 = map.det*c[0][9]*c[1][2]*map.g02;
    real G80_2_10_1 = map.det*c[0][10]*c[1][2]*map.g12;
    real G80_2_11_2 = map.det*c[0][11]*c[1][2]*map.g22;
    real G81_2_0_0 = map.det*c[1][2]*c[0][0]*map.g00;
    real G81_2_0_1 = map.det*c[1][2]*c[0][0]*map.g10;
    real G81_2_0_2 = map.det*c[1][2]*c[0][0]*map.g20;
    real G81_2_1_0 = map.det*c[1][2]*c[0][1]*map.g00;
    real G81_2_2_1 = map.det*c[1][2]*c[0][2]*map.g10;
    real G81_2_3_2 = map.det*c[1][2]*c[0][3]*map.g20;
    real G82_5_4_0 = map.det*c[1][5]*c[0][4]*map.g00;
    real G82_5_4_1 = map.det*c[1][5]*c[0][4]*map.g10;
    real G82_5_4_2 = map.det*c[1][5]*c[0][4]*map.g20;
    real G82_5_5_0 = map.det*c[1][5]*c[0][5]*map.g00;
    real G82_5_6_1 = map.det*c[1][5]*c[0][6]*map.g10;
    real G82_5_7_2 = map.det*c[1][5]*c[0][7]*map.g20;
    real G83_8_8_0 = map.det*c[1][8]*c[0][8]*map.g00;
    real G83_8_8_1 = map.det*c[1][8]*c[0][8]*map.g10;
    real G83_8_8_2 = map.det*c[1][8]*c[0][8]*map.g20;
    real G83_8_9_0 = map.det*c[1][8]*c[0][9]*map.g00;
    real G83_8_10_1 = map.det*c[1][8]*c[0][10]*map.g10;
    real G83_8_11_2 = map.det*c[1][8]*c[0][11]*map.g20;
    real G84_3_8_0 = map.det*c[0][8]*c[1][3]*map.g00;
    real G84_3_8_1 = map.det*c[0][8]*c[1][3]*map.g10;
    real G84_3_8_2 = map.det*c[0][8]*c[1][3]*map.g20;
    real G84_3_9_0 = map.det*c[0][9]*c[1][3]*map.g00;
    real G84_3_10_1 = map.det*c[0][10]*c[1][3]*map.g10;
    real G84_3_11_2 = map.det*c[0][11]*c[1][3]*map.g20;
    real G85_4_8_0 = map.det*c[0][8]*c[1][4]*map.g01;
    real G85_4_8_1 = map.det*c[0][8]*c[1][4]*map.g11;
    real G85_4_8_2 = map.det*c[0][8]*c[1][4]*map.g21;
    real G85_4_9_0 = map.det*c[0][9]*c[1][4]*map.g01;
    real G85_4_10_1 = map.det*c[0][10]*c[1][4]*map.g11;
    real G85_4_11_2 = map.det*c[0][11]*c[1][4]*map.g21;
    real G86_5_8_0 = map.det*c[0][8]*c[1][5]*map.g02;
    real G86_5_8_1 = map.det*c[0][8]*c[1][5]*map.g12;
    real G86_5_8_2 = map.det*c[0][8]*c[1][5]*map.g22;
    real G86_5_9_0 = map.det*c[0][9]*c[1][5]*map.g02;
    real G86_5_10_1 = map.det*c[0][10]*c[1][5]*map.g12;
    real G86_5_11_2 = map.det*c[0][11]*c[1][5]*map.g22;
    real G87_2_0_0 = map.det*c[1][2]*c[0][0]*map.g01;
    real G87_2_0_1 = map.det*c[1][2]*c[0][0]*map.g11;
    real G87_2_0_2 = map.det*c[1][2]*c[0][0]*map.g21;
    real G87_2_1_0 = map.det*c[1][2]*c[0][1]*map.g01;
    real G87_2_2_1 = map.det*c[1][2]*c[0][2]*map.g11;
    real G87_2_3_2 = map.det*c[1][2]*c[0][3]*map.g21;
    real G88_5_4_0 = map.det*c[1][5]*c[0][4]*map.g01;
    real G88_5_4_1 = map.det*c[1][5]*c[0][4]*map.g11;
    real G88_5_4_2 = map.det*c[1][5]*c[0][4]*map.g21;
    real G88_5_5_0 = map.det*c[1][5]*c[0][5]*map.g01;
    real G88_5_6_1 = map.det*c[1][5]*c[0][6]*map.g11;
    real G88_5_7_2 = map.det*c[1][5]*c[0][7]*map.g21;
    real G89_8_8_0 = map.det*c[1][8]*c[0][8]*map.g01;
    real G89_8_8_1 = map.det*c[1][8]*c[0][8]*map.g11;
    real G89_8_8_2 = map.det*c[1][8]*c[0][8]*map.g21;
    real G89_8_9_0 = map.det*c[1][8]*c[0][9]*map.g01;
    real G89_8_10_1 = map.det*c[1][8]*c[0][10]*map.g11;
    real G89_8_11_2 = map.det*c[1][8]*c[0][11]*map.g21;
    real G90_6_8_0 = map.det*c[0][8]*c[1][6]*map.g00;
    real G90_6_8_1 = map.det*c[0][8]*c[1][6]*map.g10;
    real G90_6_8_2 = map.det*c[0][8]*c[1][6]*map.g20;
    real G90_6_9_0 = map.det*c[0][9]*c[1][6]*map.g00;
    real G90_6_10_1 = map.det*c[0][10]*c[1][6]*map.g10;
    real G90_6_11_2 = map.det*c[0][11]*c[1][6]*map.g20;
    real G91_7_8_0 = map.det*c[0][8]*c[1][7]*map.g01;
    real G91_7_8_1 = map.det*c[0][8]*c[1][7]*map.g11;
    real G91_7_8_2 = map.det*c[0][8]*c[1][7]*map.g21;
    real G91_7_9_0 = map.det*c[0][9]*c[1][7]*map.g01;
    real G91_7_10_1 = map.det*c[0][10]*c[1][7]*map.g11;
    real G91_7_11_2 = map.det*c[0][11]*c[1][7]*map.g21;
    real G92_8_8_0 = map.det*c[0][8]*c[1][8]*map.g02;
    real G92_8_8_1 = map.det*c[0][8]*c[1][8]*map.g12;
    real G92_8_8_2 = map.det*c[0][8]*c[1][8]*map.g22;
    real G92_8_9_0 = map.det*c[0][9]*c[1][8]*map.g02;
    real G92_8_10_1 = map.det*c[0][10]*c[1][8]*map.g12;
    real G92_8_11_2 = map.det*c[0][11]*c[1][8]*map.g22;
    real G93_2_0_0 = map.det*c[1][2]*c[0][0]*map.g02;
    real G93_2_0_1 = map.det*c[1][2]*c[0][0]*map.g12;
    real G93_2_0_2 = map.det*c[1][2]*c[0][0]*map.g22;
    real G93_2_1_0 = map.det*c[1][2]*c[0][1]*map.g02;
    real G93_2_2_1 = map.det*c[1][2]*c[0][2]*map.g12;
    real G93_2_3_2 = map.det*c[1][2]*c[0][3]*map.g22;
    real G94_5_4_0 = map.det*c[1][5]*c[0][4]*map.g02;
    real G94_5_4_1 = map.det*c[1][5]*c[0][4]*map.g12;
    real G94_5_4_2 = map.det*c[1][5]*c[0][4]*map.g22;
    real G94_5_5_0 = map.det*c[1][5]*c[0][5]*map.g02;
    real G94_5_6_1 = map.det*c[1][5]*c[0][6]*map.g12;
    real G94_5_7_2 = map.det*c[1][5]*c[0][7]*map.g22;
    real G95_8_8_0 = map.det*c[1][8]*c[0][8]*map.g02;
    real G95_8_8_1 = map.det*c[1][8]*c[0][8]*map.g12;
    real G95_8_8_2 = map.det*c[1][8]*c[0][8]*map.g22;
    real G95_8_9_0 = map.det*c[1][8]*c[0][9]*map.g02;
    real G95_8_10_1 = map.det*c[1][8]*c[0][10]*map.g12;
    real G95_8_11_2 = map.det*c[1][8]*c[0][11]*map.g22;

    // Compute element tensor
    block[0] = -1.666666666666664e-01*G0_0_0 - 1.666666666666665e-01*G0_0_1 - 1.666666666666664e-01*G0_0_2 + 1.666666666666664e-01*G0_1_0 + 1.666666666666665e-01*G0_2_1 + 1.666666666666665e-01*G0_3_2 - 8.333333333333322e-02*G1_0_0 - 8.333333333333323e-02*G1_0_1 - 8.333333333333322e-02*G1_0_2 + 8.333333333333322e-02*G1_1_0 + 8.333333333333323e-02*G1_2_1 + 8.333333333333323e-02*G1_3_2 - 8.333333333333322e-02*G2_4_0 - 8.333333333333323e-02*G2_4_1 - 8.333333333333323e-02*G2_4_2 + 8.333333333333322e-02*G2_5_0 + 8.333333333333323e-02*G2_6_1 + 8.333333333333323e-02*G2_7_2 - 8.333333333333322e-02*G3_8_0 - 8.333333333333323e-02*G3_8_1 - 8.333333333333323e-02*G3_8_2 + 8.333333333333322e-02*G3_9_0 + 8.333333333333323e-02*G3_10_1 + 8.333333333333323e-02*G3_11_2 - 1.666666666666664e-01*G42_0_0_0 - 1.666666666666665e-01*G42_0_0_1 - 1.666666666666664e-01*G42_0_0_2 + 1.666666666666664e-01*G42_0_1_0 + 1.666666666666665e-01*G42_0_2_1 + 1.666666666666665e-01*G42_0_3_2 - 1.666666666666664e-01*G43_1_0_0 - 1.666666666666665e-01*G43_1_0_1 - 1.666666666666664e-01*G43_1_0_2 + 1.666666666666664e-01*G43_1_1_0 + 1.666666666666665e-01*G43_1_2_1 + 1.666666666666665e-01*G43_1_3_2 - 1.666666666666664e-01*G44_2_0_0 - 1.666666666666665e-01*G44_2_0_1 - 1.666666666666664e-01*G44_2_0_2 + 1.666666666666664e-01*G44_2_1_0 + 1.666666666666665e-01*G44_2_2_1 + 1.666666666666665e-01*G44_2_3_2 + 1.666666666666664e-01*G45_0_0_0 + 1.666666666666665e-01*G45_0_0_1 + 1.666666666666664e-01*G45_0_0_2 - 1.666666666666664e-01*G45_0_1_0 - 1.666666666666665e-01*G45_0_2_1 - 1.666666666666665e-01*G45_0_3_2 + 1.666666666666664e-01*G46_3_4_0 + 1.666666666666665e-01*G46_3_4_1 + 1.666666666666665e-01*G46_3_4_2 - 1.666666666666664e-01*G46_3_5_0 - 1.666666666666665e-01*G46_3_6_1 - 1.666666666666665e-01*G46_3_7_2 + 1.666666666666664e-01*G47_6_8_0 + 1.666666666666665e-01*G47_6_8_1 + 1.666666666666665e-01*G47_6_8_2 - 1.666666666666664e-01*G47_6_9_0 - 1.666666666666665e-01*G47_6_10_1 - 1.666666666666665e-01*G47_6_11_2;
    block[1] = -1.666666666666664e-01*G14_4_0 - 1.666666666666665e-01*G14_4_1 - 1.666666666666665e-01*G14_4_2 + 1.666666666666664e-01*G14_5_0 + 1.666666666666665e-01*G14_6_1 + 1.666666666666665e-01*G14_7_2 - 1.666666666666664e-01*G15_0_0 - 1.666666666666665e-01*G15_0_1 - 1.666666666666664e-01*G15_0_2 + 1.666666666666664e-01*G15_1_0 + 1.666666666666665e-01*G15_2_1 + 1.666666666666665e-01*G15_3_2 - 1.666666666666664e-01*G60_0_4_0 - 1.666666666666665e-01*G60_0_4_1 - 1.666666666666665e-01*G60_0_4_2 + 1.666666666666664e-01*G60_0_5_0 + 1.666666666666665e-01*G60_0_6_1 + 1.666666666666665e-01*G60_0_7_2 - 1.666666666666664e-01*G61_1_4_0 - 1.666666666666665e-01*G61_1_4_1 - 1.666666666666665e-01*G61_1_4_2 + 1.666666666666664e-01*G61_1_5_0 + 1.666666666666665e-01*G61_1_6_1 + 1.666666666666665e-01*G61_1_7_2 - 1.666666666666664e-01*G62_2_4_0 - 1.666666666666665e-01*G62_2_4_1 - 1.666666666666665e-01*G62_2_4_2 + 1.666666666666664e-01*G62_2_5_0 + 1.666666666666665e-01*G62_2_6_1 + 1.666666666666665e-01*G62_2_7_2 + 1.666666666666664e-01*G63_1_0_0 + 1.666666666666665e-01*G63_1_0_1 + 1.666666666666664e-01*G63_1_0_2 - 1.666666666666664e-01*G63_1_1_0 - 1.666666666666665e-01*G63_1_2_1 - 1.666666666666665e-01*G63_1_3_2 + 1.666666666666664e-01*G64_4_4_0 + 1.666666666666665e-01*G64_4_4_1 + 1.666666666666665e-01*G64_4_4_2 - 1.666666666666664e-01*G64_4_5_0 - 1.666666666666665e-01*G64_4_6_1 - 1.666666666666665e-01*G64_4_7_2 + 1.666666666666664e-01*G65_7_8_0 + 1.666666666666665e-01*G65_7_8_1 + 1.666666666666665e-01*G65_7_8_2 - 1.666666666666664e-01*G65_7_9_0 - 1.666666666666665e-01*G65_7_10_1 - 1.666666666666665e-01*G65_7_11_2;
    block[2] = -1.666666666666664e-01*G28_8_0 - 1.666666666666665e-01*G28_8_1 - 1.666666666666665e-01*G28_8_2 + 1.666666666666664e-01*G28_9_0 + 1.666666666666665e-01*G28_10_1 + 1.666666666666665e-01*G28_11_2 - 1.666666666666664e-01*G29_0_0 - 1.666666666666665e-01*G29_0_1 - 1.666666666666664e-01*G29_0_2 + 1.666666666666664e-01*G29_1_0 + 1.666666666666665e-01*G29_2_1 + 1.666666666666665e-01*G29_3_2 - 1.666666666666664e-01*G78_0_8_0 - 1.666666666666665e-01*G78_0_8_1 - 1.666666666666665e-01*G78_0_8_2 + 1.666666666666664e-01*G78_0_9_0 + 1.666666666666665e-01*G78_0_10_1 + 1.666666666666665e-01*G78_0_11_2 - 1.666666666666664e-01*G79_1_8_0 - 1.666666666666665e-01*G79_1_8_1 - 1.666666666666665e-01*G79_1_8_2 + 1.666666666666664e-01*G79_1_9_0 + 1.666666666666665e-01*G79_1_10_1 + 1.666666666666665e-01*G79_1_11_2 - 1.666666666666664e-01*G80_2_8_0 - 1.666666666666665e-01*G80_2_8_1 - 1.666666666666665e-01*G80_2_8_2 + 1.666666666666664e-01*G80_2_9_0 + 1.666666666666665e-01*G80_2_10_1 + 1.666666666666665e-01*G80_2_11_2 + 1.666666666666664e-01*G81_2_0_0 + 1.666666666666665e-01*G81_2_0_1 + 1.666666666666664e-01*G81_2_0_2 - 1.666666666666664e-01*G81_2_1_0 - 1.666666666666665e-01*G81_2_2_1 - 1.666666666666665e-01*G81_2_3_2 + 1.666666666666664e-01*G82_5_4_0 + 1.666666666666665e-01*G82_5_4_1 + 1.666666666666665e-01*G82_5_4_2 - 1.666666666666664e-01*G82_5_5_0 - 1.666666666666665e-01*G82_5_6_1 - 1.666666666666665e-01*G82_5_7_2 + 1.666666666666664e-01*G83_8_8_0 + 1.666666666666665e-01*G83_8_8_1 + 1.666666666666665e-01*G83_8_8_2 - 1.666666666666664e-01*G83_8_9_0 - 1.666666666666665e-01*G83_8_10_1 - 1.666666666666665e-01*G83_8_11_2;
    block[3] = -1.666666666666664e-01*G4_0_0 - 1.666666666666665e-01*G4_0_1 - 1.666666666666664e-01*G4_0_2 + 1.666666666666664e-01*G4_1_0 + 1.666666666666665e-01*G4_2_1 + 1.666666666666665e-01*G4_3_2 - 1.666666666666664e-01*G5_4_0 - 1.666666666666665e-01*G5_4_1 - 1.666666666666665e-01*G5_4_2 + 1.666666666666664e-01*G5_5_0 + 1.666666666666665e-01*G5_6_1 + 1.666666666666665e-01*G5_7_2 - 1.666666666666664e-01*G48_3_0_0 - 1.666666666666665e-01*G48_3_0_1 - 1.666666666666664e-01*G48_3_0_2 + 1.666666666666664e-01*G48_3_1_0 + 1.666666666666665e-01*G48_3_2_1 + 1.666666666666665e-01*G48_3_3_2 - 1.666666666666664e-01*G49_4_0_0 - 1.666666666666665e-01*G49_4_0_1 - 1.666666666666664e-01*G49_4_0_2 + 1.666666666666664e-01*G49_4_1_0 + 1.666666666666665e-01*G49_4_2_1 + 1.666666666666665e-01*G49_4_3_2 - 1.666666666666664e-01*G50_5_0_0 - 1.666666666666665e-01*G50_5_0_1 - 1.666666666666664e-01*G50_5_0_2 + 1.666666666666664e-01*G50_5_1_0 + 1.666666666666665e-01*G50_5_2_1 + 1.666666666666665e-01*G50_5_3_2 + 1.666666666666664e-01*G51_0_0_0 + 1.666666666666665e-01*G51_0_0_1 + 1.666666666666664e-01*G51_0_0_2 - 1.666666666666664e-01*G51_0_1_0 - 1.666666666666665e-01*G51_0_2_1 - 1.666666666666665e-01*G51_0_3_2 + 1.666666666666664e-01*G52_3_4_0 + 1.666666666666665e-01*G52_3_4_1 + 1.666666666666665e-01*G52_3_4_2 - 1.666666666666664e-01*G52_3_5_0 - 1.666666666666665e-01*G52_3_6_1 - 1.666666666666665e-01*G52_3_7_2 + 1.666666666666664e-01*G53_6_8_0 + 1.666666666666665e-01*G53_6_8_1 + 1.666666666666665e-01*G53_6_8_2 - 1.666666666666664e-01*G53_6_9_0 - 1.666666666666665e-01*G53_6_10_1 - 1.666666666666665e-01*G53_6_11_2;
    block[4] = -1.666666666666664e-01*G19_4_0 - 1.666666666666665e-01*G19_4_1 - 1.666666666666665e-01*G19_4_2 + 1.666666666666664e-01*G19_5_0 + 1.666666666666665e-01*G19_6_1 + 1.666666666666665e-01*G19_7_2 - 8.333333333333322e-02*G20_0_0 - 8.333333333333323e-02*G20_0_1 - 8.333333333333322e-02*G20_0_2 + 8.333333333333322e-02*G20_1_0 + 8.333333333333323e-02*G20_2_1 + 8.333333333333323e-02*G20_3_2 - 8.333333333333322e-02*G21_4_0 - 8.333333333333323e-02*G21_4_1 - 8.333333333333323e-02*G21_4_2 + 8.333333333333322e-02*G21_5_0 + 8.333333333333323e-02*G21_6_1 + 8.333333333333323e-02*G21_7_2 - 8.333333333333322e-02*G22_8_0 - 8.333333333333323e-02*G22_8_1 - 8.333333333333323e-02*G22_8_2 + 8.333333333333322e-02*G22_9_0 + 8.333333333333323e-02*G22_10_1 + 8.333333333333323e-02*G22_11_2 - 1.666666666666664e-01*G66_3_4_0 - 1.666666666666665e-01*G66_3_4_1 - 1.666666666666665e-01*G66_3_4_2 + 1.666666666666664e-01*G66_3_5_0 + 1.666666666666665e-01*G66_3_6_1 + 1.666666666666665e-01*G66_3_7_2 - 1.666666666666664e-01*G67_4_4_0 - 1.666666666666665e-01*G67_4_4_1 - 1.666666666666665e-01*G67_4_4_2 + 1.666666666666664e-01*G67_4_5_0 + 1.666666666666665e-01*G67_4_6_1 + 1.666666666666665e-01*G67_4_7_2 - 1.666666666666664e-01*G68_5_4_0 - 1.666666666666665e-01*G68_5_4_1 - 1.666666666666665e-01*G68_5_4_2 + 1.666666666666664e-01*G68_5_5_0 + 1.666666666666665e-01*G68_5_6_1 + 1.666666666666665e-01*G68_5_7_2 + 1.666666666666664e-01*G69_1_0_0 + 1.666666666666665e-01*G69_1_0_1 + 1.666666666666664e-01*G69_1_0_2 - 1.666666666666664e-01*G69_1_1_0 - 1.666666666666665e-01*G69_1_2_1 - 1.666666666666665e-01*G69_1_3_2 + 1.666666666666664e-01*G70_4_4_0 + 1.666666666666665e-01*G70_4_4_1 + 1.666666666666665e-01*G70_4_4_2 - 1.666666666666664e-01*G70_4_5_0 - 1.666666666666665e-01*G70_4_6_1 - 1.666666666666665e-01*G70_4_7_2 + 1.666666666666664e-01*G71_7_8_0 + 1.666666666666665e-01*G71_7_8_1 + 1.666666666666665e-01*G71_7_8_2 - 1.666666666666664e-01*G71_7_9_0 - 1.666666666666665e-01*G71_7_10_1 - 1.666666666666665e-01*G71_7_11_2;
    block[5] = -1.666666666666664e-01*G33_8_0 - 1.666666666666665e-01*G33_8_1 - 1.666666666666665e-01*G33_8_2 + 1.666666666666664e-01*G33_9_0 + 1.666666666666665e-01*G33_10_1 + 1.666666666666665e-01*G33_11_2 - 1.666666666666664e-01*G34_4_0 - 1.666666666666665e-01*G34_4_1 - 1.666666666666665e-01*G34_4_2 + 1.666666666666664e-01*G34_5_0 + 1.666666666666665e-01*G34_6_1 + 1.666666666666665e-01*G34_7_2 - 1.666666666666664e-01*G84_3_8_0 - 1.666666666666665e-01*G84_3_8_1 - 1.666666666666665e-01*G84_3_8_2 + 1.666666666666664e-01*G84_3_9_0 + 1.666666666666665e-01*G84_3_10_1 + 1.666666666666665e-01*G84_3_11_2 - 1.666666666666664e-01*G85_4_8_0 - 1.666666666666665e-01*G85_4_8_1 - 1.666666666666665e-01*G85_4_8_2 + 1.666666666666664e-01*G85_4_9_0 + 1.666666666666665e-01*G85_4_10_1 + 1.666666666666665e-01*G85_4_11_2 - 1.666666666666664e-01*G86_5_8_0 - 1.666666666666665e-01*G86_5_8_1 - 1.666666666666665e-01*G86_5_8_2 + 1.666666666666664e-01*G86_5_9_0 + 1.666666666666665e-01*G86_5_10_1 + 1.666666666666665e-01*G86_5_11_2 + 1.666666666666664e-01*G87_2_0_0 + 1.666666666666665e-01*G87_2_0_1 + 1.666666666666664e-01*G87_2_0_2 - 1.666666666666664e-01*G87_2_1_0 - 1.666666666666665e-01*G87_2_2_1 - 1.666666666666665e-01*G87_2_3_2 + 1.666666666666664e-01*G88_5_4_0 + 1.666666666666665e-01*G88_5_4_1 + 1.666666666666665e-01*G88_5_4_2 - 1.666666666666664e-01*G88_5_5_0 - 1.666666666666665e-01*G88_5_6_1 - 1.666666666666665e-01*G88_5_7_2 + 1.666666666666664e-01*G89_8_8_0 + 1.666666666666665e-01*G89_8_8_1 + 1.666666666666665e-01*G89_8_8_2 - 1.666666666666664e-01*G89_8_9_0 - 1.666666666666665e-01*G89_8_10_1 - 1.666666666666665e-01*G89_8_11_2;
    block[6] = -1.666666666666664e-01*G9_0_0 - 1.666666666666665e-01*G9_0_1 - 1.666666666666664e-01*G9_0_2 + 1.666666666666664e-01*G9_1_0 + 1.666666666666665e-01*G9_2_1 + 1.666666666666665e-01*G9_3_2 - 1.666666666666664e-01*G10_8_0 - 1.666666666666665e-01*G10_8_1 - 1.666666666666665e-01*G10_8_2 + 1.666666666666664e-01*G10_9_0 + 1.666666666666665e-01*G10_10_1 + 1.666666666666665e-01*G10_11_2 - 1.666666666666664e-01*G54_6_0_0 - 1.666666666666665e-01*G54_6_0_1 - 1.666666666666664e-01*G54_6_0_2 + 1.666666666666664e-01*G54_6_1_0 + 1.666666666666665e-01*G54_6_2_1 + 1.666666666666665e-01*G54_6_3_2 - 1.666666666666664e-01*G55_7_0_0 - 1.666666666666665e-01*G55_7_0_1 - 1.666666666666664e-01*G55_7_0_2 + 1.666666666666664e-01*G55_7_1_0 + 1.666666666666665e-01*G55_7_2_1 + 1.666666666666665e-01*G55_7_3_2 - 1.666666666666664e-01*G56_8_0_0 - 1.666666666666665e-01*G56_8_0_1 - 1.666666666666664e-01*G56_8_0_2 + 1.666666666666664e-01*G56_8_1_0 + 1.666666666666665e-01*G56_8_2_1 + 1.666666666666665e-01*G56_8_3_2 + 1.666666666666664e-01*G57_0_0_0 + 1.666666666666665e-01*G57_0_0_1 + 1.666666666666664e-01*G57_0_0_2 - 1.666666666666664e-01*G57_0_1_0 - 1.666666666666665e-01*G57_0_2_1 - 1.666666666666665e-01*G57_0_3_2 + 1.666666666666664e-01*G58_3_4_0 + 1.666666666666665e-01*G58_3_4_1 + 1.666666666666665e-01*G58_3_4_2 - 1.666666666666664e-01*G58_3_5_0 - 1.666666666666665e-01*G58_3_6_1 - 1.666666666666665e-01*G58_3_7_2 + 1.666666666666664e-01*G59_6_8_0 + 1.666666666666665e-01*G59_6_8_1 + 1.666666666666665e-01*G59_6_8_2 - 1.666666666666664e-01*G59_6_9_0 - 1.666666666666665e-01*G59_6_10_1 - 1.666666666666665e-01*G59_6_11_2;
    block[7] = -1.666666666666664e-01*G23_4_0 - 1.666666666666665e-01*G23_4_1 - 1.666666666666665e-01*G23_4_2 + 1.666666666666664e-01*G23_5_0 + 1.666666666666665e-01*G23_6_1 + 1.666666666666665e-01*G23_7_2 - 1.666666666666664e-01*G24_8_0 - 1.666666666666665e-01*G24_8_1 - 1.666666666666665e-01*G24_8_2 + 1.666666666666664e-01*G24_9_0 + 1.666666666666665e-01*G24_10_1 + 1.666666666666665e-01*G24_11_2 - 1.666666666666664e-01*G72_6_4_0 - 1.666666666666665e-01*G72_6_4_1 - 1.666666666666665e-01*G72_6_4_2 + 1.666666666666664e-01*G72_6_5_0 + 1.666666666666665e-01*G72_6_6_1 + 1.666666666666665e-01*G72_6_7_2 - 1.666666666666664e-01*G73_7_4_0 - 1.666666666666665e-01*G73_7_4_1 - 1.666666666666665e-01*G73_7_4_2 + 1.666666666666664e-01*G73_7_5_0 + 1.666666666666665e-01*G73_7_6_1 + 1.666666666666665e-01*G73_7_7_2 - 1.666666666666664e-01*G74_8_4_0 - 1.666666666666665e-01*G74_8_4_1 - 1.666666666666665e-01*G74_8_4_2 + 1.666666666666664e-01*G74_8_5_0 + 1.666666666666665e-01*G74_8_6_1 + 1.666666666666665e-01*G74_8_7_2 + 1.666666666666664e-01*G75_1_0_0 + 1.666666666666665e-01*G75_1_0_1 + 1.666666666666664e-01*G75_1_0_2 - 1.666666666666664e-01*G75_1_1_0 - 1.666666666666665e-01*G75_1_2_1 - 1.666666666666665e-01*G75_1_3_2 + 1.666666666666664e-01*G76_4_4_0 + 1.666666666666665e-01*G76_4_4_1 + 1.666666666666665e-01*G76_4_4_2 - 1.666666666666664e-01*G76_4_5_0 - 1.666666666666665e-01*G76_4_6_1 - 1.666666666666665e-01*G76_4_7_2 + 1.666666666666664e-01*G77_7_8_0 + 1.666666666666665e-01*G77_7_8_1 + 1.666666666666665e-01*G77_7_8_2 - 1.666666666666664e-01*G77_7_9_0 - 1.666666666666665e-01*G77_7_10_1 - 1.666666666666665e-01*G77_7_11_2;
    block[8] = -1.666666666666664e-01*G38_8_0 - 1.666666666666665e-01*G38_8_1 - 1.666666666666665e-01*G38_8_2 + 1.666666666666664e-01*G38_9_0 + 1.666666666666665e-01*G38_10_1 + 1.666666666666665e-01*G38_11_2 - 8.333333333333322e-02*G39_0_0 - 8.333333333333323e-02*G39_0_1 - 8.333333333333322e-02*G39_0_2 + 8.333333333333322e-02*G39_1_0 + 8.333333333333323e-02*G39_2_1 + 8.333333333333323e-02*G39_3_2 - 8.333333333333322e-02*G40_4_0 - 8.333333333333323e-02*G40_4_1 - 8.333333333333323e-02*G40_4_2 + 8.333333333333322e-02*G40_5_0 + 8.333333333333323e-02*G40_6_1 + 8.333333333333323e-02*G40_7_2 - 8.333333333333322e-02*G41_8_0 - 8.333333333333323e-02*G41_8_1 - 8.333333333333323e-02*G41_8_2 + 8.333333333333322e-02*G41_9_0 + 8.333333333333323e-02*G41_10_1 + 8.333333333333323e-02*G41_11_2 - 1.666666666666664e-01*G90_6_8_0 - 1.666666666666665e-01*G90_6_8_1 - 1.666666666666665e-01*G90_6_8_2 + 1.666666666666664e-01*G90_6_9_0 + 1.666666666666665e-01*G90_6_10_1 + 1.666666666666665e-01*G90_6_11_2 - 1.666666666666664e-01*G91_7_8_0 - 1.666666666666665e-01*G91_7_8_1 - 1.666666666666665e-01*G91_7_8_2 + 1.666666666666664e-01*G91_7_9_0 + 1.666666666666665e-01*G91_7_10_1 + 1.666666666666665e-01*G91_7_11_2 - 1.666666666666664e-01*G92_8_8_0 - 1.666666666666665e-01*G92_8_8_1 - 1.666666666666665e-01*G92_8_8_2 + 1.666666666666664e-01*G92_8_9_0 + 1.666666666666665e-01*G92_8_10_1 + 1.666666666666665e-01*G92_8_11_2 + 1.666666666666664e-01*G93_2_0_0 + 1.666666666666665e-01*G93_2_0_1 + 1.666666666666664e-01*G93_2_0_2 - 1.666666666666664e-01*G93_2_1_0 - 1.666666666666665e-01*G93_2_2_1 - 1.666666666666665e-01*G93_2_3_2 + 1.666666666666664e-01*G94_5_4_0 + 1.666666666666665e-01*G94_5_4_1 + 1.666666666666665e-01*G94_5_4_2 - 1.666666666666664e-01*G94_5_5_0 - 1.666666666666665e-01*G94_5_6_1 - 1.666666666666665e-01*G94_5_7_2 + 1.666666666666664e-01*G95_8_8_0 + 1.666666666666665e-01*G95_8_8_1 + 1.666666666666665e-01*G95_8_8_2 - 1.666666666666664e-01*G95_8_9_0 - 1.666666666666665e-01*G95_8_10_1 - 1.666666666666665e-01*G95_8_11_2;
  }
        
private:

  const real& c0;  const real& c1;  const real& c2;

};

} }

#endif
